# Project monitoring

Voici le project Monitoring de notre groupe composé de TRAN Alain, CRECSENDRE Cassandre et MACE Lloyd.

## Mise en place du Gitlab

Mise en place de git comme solution de versionnage du projet et de partage du répertoire de travail. 

- Responsable : Alain TRAN  
- Séance : 1  
- Commit :  

Ouverture d'un projet sur le gitlab de l'école et clonage du répertoire pour chacun des membres du groupe.  
URL sur gitlab [http://gvipers.imt-lille-douai.fr/alain.tran/projet_info.git]

## Upload et étude du projet des professeurs

Téléchargement du projet TicTacToeCodeingame écrit par les professeurs sur une ide Java (Netbeans sur notre groupe) et upload du projet sur la branche Master du Gitlab.

- Responsable : Alain TRAN  
- Séance : 1  
- Commit : 1a090909b9b27611fde1c0a47a6754263fcbf210  

Etude du projet et des différentes classes afin de comprendre le programme initial.

## Classe Ordi_vs_Ordi (terminé)

Création de la classe Ordi_vs_ordi pour que deux joueurs Ordis s'affrontent sur le jeu TicTacToe.

- Responsable : Alain TRAN
- Séance : 2
- Commit : efad39ce3df7809677e42e629436af5e019b60b7

Cette classe permet de faire jouer deux joueurs Ordis entre eux. Ainsi nous pourrons analyser nos algorithmes dans différentes configuration et voir comment un joueur Ordi
travaillant avec un certain algorithme joue contre un autre joueur Ordi avec un autre algorithme. On pourra ainsi comparer les algorithmes entre eux.

## Séparation du travail et création branches

Répartition du travail entre les différents membres du groupe et création des branches correspondantes

- Responsables : Alain TRAN, CRECSENDRE Cassandre, MACE LLOYD
- Séance : 2
- Commit :

Répartition du travail parmi les différents membres du groupe. Alain TRAN va travailler sur l'algorithme MinMax tandis que LLoyd MACE et Cassandre CRESCENDRE vont travailler sur
l'algorithme de Monte Carlo recherche arborescente.

# Branche MinMax_Alain

## Classe AlgoRechercheMinMax

Création de la classe AlgorechercheMinMax dans le même repository TicTacToeCodeingame qui implémente l'algorithme MinMax.

- Responsable : Alain TRAN
- Séance : 2 - 3 - ... (en cours)
- Commit : f63e7648e644f139f5ef9981b80d9f38cea874f3

Création de la classe MinMax et recherche des méthodes correspondantes en adéquation avec le programme déjà écrit (pour avoir un @Override correct).

## Classe AlgoRechercheMinMax - Méthode meilleurCoup

Création de la méthode meilleurCoup dans la classe AlgoRechercheMinMax.

- Responsable : Alain TRAN
- Séance : 3
- Commit : f63e7648e644f139f5ef9981b80d9f38cea874f3

La méthode meilleurCoup va permettre à l'ordinateur de choisir le coup qui dispose du meilleur score et donc de la meilleur chance de gagner. Cette méthode sera celle qui 
sera override par la méthode meilleurCoup déjà existante dans la classe AlgoRecherche. Celle-ci utilisera également une autre méthode récursive minmax pas encore crée.

## Classe AlgoRechercheMinMax - Méthode minmax

Création et modification de la méthode minmax dans la classe AlgoRechercheMinMax.

- Responsable : Alain TRAN
- Séance : 3 - ... (contient des erreurs)
- Commit : 38cb9e1950087ed681dfa5a37e93176dc79a3aa4

Cette méthode est récursive et est celle qui va nous permettre de faire des simulations selon les coups joués et d'attribuer un score à chaque configuration possible à
partir d'une configuration donnée (par la liste des coups possibles et joués pour tel joueur).

# Branche mcts_cassandre 

## Mise en place de la classe Node 

La classe Node nous permet la modélisation des noeuds de l'arbre qui nous sera utile pour le MCTS.

-Responsable: Cassandre, Lloyd  
-Séance: 2  
-Commit: 3f1ee451339eb4bfab6050b3ab7ff5db9543bf35  

Dans cette classe nous trouvons la liste des noeud enfant ( associé à leur coup), leur état ( qui permettra de calculer l'UCT du noeud), et le noeud parent.
On y trouve également les getters et setters associés aux éléments de la classe.

## Modification de la classe Node (terminé)


Modification de classe Node qui permet d'associer le dernier coup de la configuration au noeud considérer. Et Childarray devient une liste de noeud ( et non de coups)

-Responsable: Cassandre, Lloyd  
-Séance: 3  
-Commit: 253f3076df42ca0f9c628612a5cd6d72f37ef496  

## Mise en place de la classe State (terminé)

La classe State donne des informations sur un noeud considéré. Ces informations nous permettront de calculer l'UCT du noeud considéré.

-Responsable: Lloyd, Cassandre  
-Séance: 2  
-Commit: 4445a8096b8e8a2ebbbf05e84a63f0acda63f5b5  

Cette classe nous permet de déterminer la configuration du plateau, le joueur, le nombre de visite et de victoire associé à ce noeud.
On y trouve également les getters et setters associés aux éléments de la classe.

## Mise en place de la classe Tree (terminé)

Cette classe assure la continuité de la modélisation de l'arbre de l'algorithme MCTS avec les noeuds.

-Responsable: Cassandre, Lloyd  
-Séance: 2  
-Commit: 27df24df65674b8bd31020e811bd8f190ff1a757  

La classe contient les setters et getters associés à la liste des noeuds constituants l'arbre.

## Mise en place des différentes étapes du MCTS (en cours)

C'est cette classe qui orchestre l'algorithme du MCTS

-Responsable: Cassandre, Lloyd  
-Séance: 2, 3  
-Commit: 7947fda71961db7e11a47d6f4a261a0cc7312b53  

On y trouve les différentes méthodes associées à chaque étape du MCTS ( sélection, expansion, simulation, backpropagation).

### Phase sélection (terminé):
- uctValue() permet de calculer l'UCT associé à un noeud
- selectNodeWithBestUCT() : sélectionne le noeud qui a le plus grand UCT

### Phase expansion (terminé):
- expandNode() : création d'un nouveau noeud, paramètrage de son State

### Phase simulation (en cours):
- simulationFromNode(): permet de simuler une partie à partir de la configuration du jeu associée à un noeud ( retourne un booléen : vraie si la partie est gagné)

### Phase backpropagation (en cours):
- backpropagation(): paramètre tous les noeuds des configurations associés à la simulation (paramètre visitcount et winscore) selon si la simulation est gagnante ou pas.

### Phase finale : l'association de toutes ces étapes dans la méthode meilleurecoup() ( à commencer)
La méthode meilleure cour permet de jouer le coup choisit par l'algo MCTS.




